--[[
	@title:  	Test
	@describe:  测试代码
]]

package.path = package.path .. ";src/?.lua"

function string.split(input, delimiter)
    input = tostring(input)
    delimiter = tostring(delimiter)
    if (delimiter=='') then return false end
    local pos,arr = 0, {}
    -- for each divider found
    for st,sp in function() return string.find(input, delimiter, pos, true) end do
        table.insert(arr, string.sub(input, pos, st - 1))
        pos = sp + 1
    end
    table.insert(arr, string.sub(input, pos))
    return arr
end

function string.trim(input)
    input = string.gsub(input, "^[ \t\n\r]+", "")
    return string.gsub(input, "[ \t\n\r]+$", "")
end

local function dump_value_(v)
    if type(v) == "string" then
        v = "\"" .. v .. "\""
    end
    return tostring(v)
end

function dump(value, desciption, nesting)
    if type(nesting) ~= "number" then nesting = 9 end
	
    local lookupTable = {}
    local result = {}
	
    local traceback = string.split(debug.traceback("", 2), "\n")
    print("dump from: " .. string.trim(traceback[3]))
	
    local function dump_(value, desciption, indent, nest, keylen)
        desciption = desciption or "<var>"
        local spc = ""
        if type(keylen) == "number" then
            spc = string.rep(" ", keylen - string.len(dump_value_(desciption)))
        end
        if type(value) ~= "table" then
            result[#result +1 ] = string.format("%s%s%s = %s", indent, dump_value_(desciption), spc, dump_value_(value))
        elseif lookupTable[tostring(value)] then
            result[#result +1 ] = string.format("%s%s%s = *REF*", indent, dump_value_(desciption), spc)
        else
            lookupTable[tostring(value)] = true
            if nest > nesting then
                result[#result +1 ] = string.format("%s%s = *MAX NESTING*", indent, dump_value_(desciption))
            else
                result[#result +1 ] = string.format("%s%s = {", indent, dump_value_(desciption))
                local indent2 = indent.."    "
                local keys = {}
                local keylen = 0
                local values = {}
                for k, v in pairs(value) do
                    keys[#keys + 1] = k
                    local vk = dump_value_(k)
                    local vkl = string.len(vk)
                    if vkl > keylen then keylen = vkl end
                    values[k] = v
                end
                table.sort(keys, function(a, b)
                    if type(a) == "number" and type(b) == "number" then
                        return a < b
                    else
                        return tostring(a) < tostring(b)
                    end
                end)
                for i, k in ipairs(keys) do
                    dump_(values[k], k, indent2, nest + 1, keylen)
                end
                result[#result +1] = string.format("%s}", indent)
            end
        end
    end
    dump_(value, desciption, "- ", 1)
	
    for i, line in ipairs(result) do
        print(line)
    end
end

--GlobalFunction.SplitStr("123&8973a&aaa","&")

--local testimage = ccui.ImageView:create()
--testimage:loadWebImage("http://source01.ddz.shangyoo.com/hbs/10007/1519377060bwxjhbs20180223.png")
--self:addChild(testimage)

--local test = {"1", "2", {"3"}, "4"}
--for i,v in ipairs(test) do
--	if i == 3 then
--		v = "333"
--	end
--end
--
--for i, v in ipairs(test) do
--	local item = test[i]
--	if type(item) == "table" then
--		for i1,v1 in ipairs(item) do
--			print("i1=, v1=", i1, item[i1])
--		end
--	else
--		print("i=, v=", i, item)
--	end
--end

--local function AAAA()
--	local i = 0
--	local function BBBB()
--		print("1111--i=", i)
--		i = 3
--		print("2222--i=", i)
--	end
--	print("3333----i=", i)
--	i = 1
--	BBBB()
--	print("4444----i=", i)
--end
--
--AAAA()
--AAAA()

--[[local test = {
	111,
	112,
	110,
	109,
	108,
	107,
	106,
	105,
	113,
	114,
}
for k,v in ipairs(test) do
	print("k=,v=", k, v)
end
for k,v in pairs(test) do
	print("k=,v=", k, v)
end
table.sort(test)
print("--------------------")
for k,v in ipairs(test) do
	print("k=,v=", k, v)
end
for k,v in pairs(test) do
	print("k=,v=", k, v)
end--]]

--[[local test = {
	[1] = 112,
	[7] = "abc",
	[4] = {111},
	[2] = false,
}
for k,v in ipairs(test) do
	print("k=,v=", k, v)
end
for k,v in pairs(test) do
	print("k=,v=", k, v)
end--]]

--[[local url = "http://source01.ddz.shangyoo.com/djs/rule/dbmjrule201812041659.png"
--url = "http://activityhxddz.syyx.com/index3?appid=1404&ver=3.10.160&imei=008796757205508&chn=02&uid=-1294967039&nickname=%E7%94%A8%E6%88%B700294837286&sex=1&beans=39599&win=0&lose=0&cert=48EDF8EC7412259C46DA49FD66BB62C3&net=unkown&phonenumber=&serverid=1&servercode=370&sign=316F4FCBB2B774ECD985E247EB6AE0E2&gameid=0%7C1%7C2%7C8"
local filename = string.match(url, ".+/([^/]*%.%w+)$")
print(filename)--]]

--[[local test = {
	[1] = 112,
	[7] = "abc",
	[4] = {111},
	[2] = false,
}
print(test[nil])

local function AAAA()
	local t = {}
	print("0000--t=", t)
	dump(t, "0000")
	return function ()
		print("1111--t=", t)
		dump(t, "1111")
		t[1] = 1
		print("2222--t=", t)
		dump(t, "2222")
		return t
	end
end

local bFun = AAAA()
local t = bFun()
print("3333--t=", t)
dump(t, "3333")
t[2] = 2
print("4444--t=", t)
dump(t, "4444")

local t1 = bFun()
t1["huliang"] = "huliang"
print("5555--t1=", t1)
dump(t1, "5555")--]]

--[[local test = 123
print("test=", tostring(test))
print(string.format("哈哈", tostring(test)))--]]

print(string.format("找回%d%%", 100))
