--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local ControllerManager = class("ControllerManager")
local NetMgr = require("src/net/NetMgr")
require "lfs"
local snapshot = require "snapshot"
local memleakdetectv2 = require("src/managers/memleakdetectv2")
menleakS1= {}
--扩展os包
function os.exists(path)
    return CCFileUtils:sharedFileUtils():isFileExist(path)
end

--控制器管理配置
ControllerManager.config = {
    {
        gameID = 12,
        gameName = "mahjong",
        controllName = "XZDDGameController",
        controllPath = "app/mahjong/controller/XZDDGameController",
        initPath = "app/mahjong/init",
        LuaClearPath = "app/mahjong/luaFinalizer",
        GameStartCmdName = "XZDDStartGame",
    },
    {
    	gameID = 13,
		gameName = "mahjong_xueliu",
		controllName = "XLCHGameController",
		controllPath = "app/mahjong_xueliu/controller/XLCHGameController",
		initPath = "app/mahjong_xueliu/init",
        LuaClearPath = "app/mahjong_xueliu/luaFinalizer",
        GameStartCmdName = "XLCHStartGame",
    },
    {
        gameID = 15,
        gameName = "fish"  , 
        controllName = "enterFishController" ,
        controllPath = "app/fish/enterController/enterFishController",
        initPath = "app/fish/init",
        LuaClearPath = "app/fish/luaFinalizer",
        GameStartCmdName = "FISH_START_GAME"
    }, 
    {
        gameID = 17,
        gameName = "mahjong_hall"  , 
        controllName = "MJHallController" ,
        controllPath = "app/mahjong_hall/controller/MJHallController",
        initPath = "app/mahjong_hall/MJHallInit",
        LuaClearPath = "app/mahjong_hall/luaFinalizer",
        GameStartCmdName = "MJHALLStartGame"
    },
	{
		gameID = 700,
        gameName = "activity",
        controllName = "ActivityController",
        controllPath = "app/activity/controller/ActivityController",
        initPath = "app/activity/init",
        LuaClearPath = "app/activity/luaFinalizer",
        GameStartCmdName = "ActivityStartModule"
	},
}

--加载游戏配置【此接口目前在android上有问题】
function ControllerManager:loadGameConfig()
	local rootPath = lfs.currentdir().."src/app"
	print("ControllerManager:loadGameConfig--rootPath=", rootPath)
    for entry in lfs.dir(rootPath) do
        if entry ~= '.' and entry ~= '..' then
            local cfgpath = "src/app/" .. entry .. '/game_config.lua'
            print("ControllerManager:loadGameConfig--cfgpath=", cfgpath)
            if os.exists(cfgpath) then
                local gameCfg = require(cfgpath)
                local isLoad = false
                for k,v in pairs(ControllerManager.config) do
                    if gameCfg.gameID == v.gameID then -- 找到对应的游戏ID
                        isLoad = true
                    end
                end
                if isLoad == false then
                    table.insert(ControllerManager.config,gameCfg)
                end
            end
        end
    end
end

--构造函数
function ControllerManager:ctor()
    print("ControllerManager:ctor")
    self._controllers = {}--一个游戏id 对应一个controller
    self._controllers["HallController"] = require("app/hall/controller/HallController"):new()
	self._curControllerName = nil
	
	--注册启动游戏网络消息
    NetMgr.Register("StartGame", handler(self, self.StartGame))
    --监听清理lua内存文件事件
    local listener = cc.EventListenerCustom:create("ClearLuaFinalizer", handler(self, self.ClearLuaFinalizer))
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1)
end

--析构函数【自定义-需要主动调用】
function ControllerManager:dtor()
    NetMgr.UnRegister("StartGame")
end

--启动游戏入口
function ControllerManager:StartGame(strName,MsgData)
    print("ControllerManager:StartGame--strName=, MsgData=", strName, MsgData)
    menleakS1 = snapshot()
    --memleakdetectv2.detec_begin()
    for k,v in pairs(ControllerManager.config) do
        if MsgData == v.gameID then -- 找到对应的游戏ID
			if self._controllers[v["controllName"]] == nil then
				require(v.initPath)--初始化对应的值
				self._controllers[v["controllName"]] = require(v.controllPath):new()
				NetMgr_onMessageIDataX(v.GameStartCmdName)
			end
        end
    end
    return true,1
end

--清理接口
function ControllerManager:ClearLuaFinalizer(event)
    print("ControllerManager:ClearLuaFinalizer--event._userdata[1]=", event._userdata[1])
    self.clearGameID = event._userdata[1]
    performFunction(function()
        for k,v in pairs(ControllerManager.config) do
            if self.clearGameID == v.gameID then -- 找到对应的游戏ID
                if self._controllers[v["controllName"]] then
                    self._controllers[v["controllName"]]:dtor()
					self._controllers[v["controllName"]] = nil
                    package.loaded[v["LuaClearPath"]] = nil
                end
            end
        end
        clearLuaRequire(self.clearGameID)
        print("ControllerManager:ClearLuaFinalizer--performFunction self.clearGameID=", self.clearGameID)
        self.checkMemLeak()
    end,0.0001)--下一帧就执行
end

--检测内存泄漏
function ControllerManager:checkMemLeak()
    print("ControllerManager:checkMemLeak-- start ------------------ ")
    collectgarbage("collect")
    local S2 = snapshot()
    for k,v in pairs(S2) do
	    if menleakS1[k] == nil then
		    print(k,v)
	    end
    end
    print("ControllerManager:checkMemLeak-- end --------------------")
end

--[[
	获取当前运行的Controller对象
    一个游戏对应一个Controller
]]
function ControllerManager:getCurController()
    if self._curControllerName == nil then
        return nil
    end
    for i , v in pairs( self._controllers ) do
        if type(self._curControllerName) == "string" and self._curControllerName == i then
            return v
        end
    end
    return nil
end

--[[
	获取对应名称的Controller对象
]]
function ControllerManager:getControllerByName(strControllerName)
	if type(strControllerName) == "string" then
		for k, v in pairs(self._controllers) do
			if strControllerName == k then
				return v
			end
		end
	end
    return nil
end

--[[
	设置当前运行的Controller
]]
function ControllerManager:setCurController(strControllerName)
    if self:isHaveControllerByControllerName(strControllerName) then
		self._curControllerName = strControllerName
    else
		print("[LUA ERROR]--ControllerManager:setCurController--controller isn't exist, strControllerName=", strControllerName)
		self._curControllerName = nil
    end
end

--[[
	重置当前Controller
]]
function ControllerManager:resetCurController()
    self._curControllerName  = nil
end

--[[
    通过controller名判断是否存在controller对象
]]
function ControllerManager:isHaveControllerByControllerName(controllerName)
	return (self._controllers[controllerName] ~= nil)
end

--[[
    通过controller名和modle名获取modle对象
]]
function ControllerManager:getModleByControllerAndModleName(strControllerName, strModleName)
    if type(strControllerName) ~= "string" or type(strModleName) ~= "string" then 
        print("[LUA ERROR]--strControllerName or strModleName is not string")
        return nil
    end
	
    local controller = self:getControllerByName(strControllerName)
    if controller == nil then
        print("[LUA ERROR]--controller is null, strControllerName=", strControllerName)
        return nil
    end
	
    if controller.getModleByName ~= nil then 
        return controller:getModleByName(strModleName)    
    end
	
    return nil
end

--[[
    通过controller名字移除controller对象
]]
function ControllerManager:removeControllerByName(strControllerName)
	if type(strControllerName) == "string" then
		self._controllers[strControllerName]:dtor()
		self._controllers[strControllerName] = nil
	end
end

--[[
    通过gameid获取controller名字
]]
function ControllerManager:getControllerNameByGameID(gameid)
	for k,v in pairs(ControllerManager.config) do
		if v.gameID == gameid then
			return v.controllName
		end
	end
	return ""
end

--[[
    通过gameid判断是否存在controller对象
]]
function ControllerManager:isHaveControllerByGameID(gameid)
	local controllerName = self:getControllerNameByGameID(gameid)
	if string.len(controllerName) > 0 then
		return self:isHaveControllerByControllerName(controllerName)
	end
	return false
end


cc.ControllerManager = cc.ControllerManager or ControllerManager:new()

--endregion
